package com.themes.fancy.keyboard.keyboard

import android.app.Application
import android.graphics.Typeface
import com.themes.fancy.keyboard.keyboard.data.Class
import com.themes.fancy.keyboard.keyboard.data.KbSource
//import com.pretty.keyboard.theme.keyboard.helper.ObjectBox
import org.json.JSONArray
import java.io.BufferedReader
import java.io.IOException
import java.io.InputStream
import java.io.InputStreamReader
import java.io.StringWriter

class MyApplication : Application() {
    companion object {
        lateinit var appInstance: MyApplication

        lateinit var list: MutableList<Class>

        const val TAG = "-----------------"
        var defaultFont: Typeface? = null
        const val DB_VERSION = 1
        const val DB_NAME = "KEy"
    }

    override fun onCreate() {
        super.onCreate()
        appInstance = this
//        ObjectBox.init(this)
        defaultFont = Typeface.createFromAsset(assets, "Bold.ttf")
        dealFile()

    }

    private fun dealFile() {
        val openFile = appInstance.assets.open("data.json")
        val jsonString = getJsonString(openFile)
        if (jsonString != null) {
            resolveJsonString(jsonString)
        }
    }


    private fun resolveJsonString(string: String) {
        val jsonData = JSONArray(string)
        var dataList: MutableList<Class> = mutableListOf()
        for (i in 0 until jsonData.length()) {
            jsonData.getJSONObject(i).run {
                val pName = getString("parent_name")
                val listArray = getJSONArray("keyboard_list")
                var kbSourceList: MutableList<KbSource> = mutableListOf()
                for (listIndex in 0 until listArray.length()) {
                    listArray.getJSONObject(listIndex).also {
                        val title = it.getString("title")
                        val thUrl = it.getString("thumbUrl")
                        val thGif = it.getString("thumbUrlGif")
                        var zipPath = ""
                        var imgPath = ""
                        var imgGif = ""
                        var imgPreviewGif = ""
                        if (it.has("detail")) {
                            val contentObject =
                                it.getJSONObject("detail").getJSONObject("themeContent")
                            zipPath = contentObject.getString("androidRawZipUrl")
                            imgPath = contentObject.getString("img")
                            imgGif = contentObject.getString("imgGif")
                            imgPreviewGif = contentObject.getString("imgPreviewGif")
                        } else {

                        }
                        kbSourceList.add(
                            KbSource().apply {
                            setImgPath(imgPath)
                            setZipPath(zipPath)
                            setTitleName(title)
                            setImgGif(imgGif)
                            thumbUrl = thUrl
                            thumbGif = thGif
                        })

                    }

                }

                val dataClass = Class()
                    .apply {
                    parentName = pName
                    keyboardList = kbSourceList
                }
                dataList.add(dataClass)

            }
        }

        updateDataList(dataList)

    }

    private fun updateDataList(mainList: MutableList<Class>) {
        list = mainList

    }
    private fun getJsonString(fileInputStream: InputStream): String? {
        return try {
            //            FileInputStream fileInputStream = new FileInputStream(path);
            val charArray = CharArray(fileInputStream.available())
            var readCount = 0
            val streamReader = InputStreamReader(fileInputStream)
            val bufferedReader = BufferedReader(streamReader)
            val stringWriter = StringWriter()
            while (bufferedReader.read(charArray).also { readCount = it } != -1) {
                stringWriter.write(charArray, 0, readCount)
            }
            stringWriter.toString()
        } catch (e: IOException) {
            ""
        }
    }



}